unit macro_rec_f;
  /////////////////////////////////////////////////////////
  //                                                     //
  //          TMacroMagic-Component: a demo              //
  //                                                     //
  // (C) Niels Vanspauwen, 19-03-1998                    //
  //     E-mail: Niels.Vanspauwen@Student.Kuleuven.Ac.Be //
  //                                                     //
  /////////////////////////////////////////////////////////
  {This is a demo to demonstrate the use of the TMacroMagic-component.
   Click on File-New to assign a name to your macro. (extension is
   automatically set to .mcr, regardless of the extension you give)
   Now press the "Record"-button and move around with the mouse a bit.
   Click on the "Test Auto-speed Addaption"-button. This perform a
   very simple loop: the computer starts counting from 1 to 1000.
   Notice that you cannot move the cursor while the PC is performing
   this loop.
   When the loop is done, click on the "Stop Recording"-button.
   The macro is automatically saved to disk.
   Now press the "Play"-button and playback will start.
   Not impressed ? After the playback has ended, set one of the
   radio-buttons to "Simulate 5x slower" or "Simulate 5x faster" and
   press play again. As you'll notice, the macro nicely waits untill
   the PC is done counting before playback continues !
   Be sure to check the docs that come with this component to read all
   about the "how and why" of this feature.
   }

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Menus, TRescaler_c, MacroMagic, ExtCtrls;

type
  TForm1 = class(TForm)
    RecordButton: TButton;
    StopButton: TButton;
    PlayButton: TButton;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    New1: TMenuItem;
    Open1: TMenuItem;
    N1: TMenuItem;
    Exit1: TMenuItem;
    OpenDialog1: TOpenDialog;
    MacroMagic: TMacroMagic;
    Button1: TButton;
    RadioGroup1: TRadioGroup;
    procedure RecordButtonClick(Sender: TObject);
    procedure StopButtonClick(Sender: TObject);
    procedure PlayButtonClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure New1Click(Sender: TObject);
    procedure Open1Click(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure MacroMagicPlayEnded;
    procedure MacroMagicRecordEnded;
    procedure Button1Click(Sender: TObject);
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.RecordButtonClick(Sender: TObject);
begin
RecordButton.Enabled:=false;
PlayButton.Enabled:=False;
StopButton.Enabled:=true;
MacroMagic.StartRecording;
end; {procedure RecordButtonClick}


procedure TForm1.StopButtonClick(Sender: TObject);
begin
MacroMagic.StopRecording;
end; {procedure StopButtonClick}


procedure TForm1.PlayButtonClick(Sender: TObject);
begin
try
  MacroMagic.Play;
  PlayButton.Enabled:=false;
  RecordButton.Enabled:=False;
  StopButton.Enabled:=false;
except on ENoSuchMacro do
  ShowMessage('Macro does not exist !');
end; {exception handler}
end; {procedure PlayButtonClick}


procedure TForm1.FormCreate(Sender: TObject);
begin
RecordButton.Enabled:=false;
PlayButton.Enabled:=false;
StopButton.Enabled:=false;
end;

procedure TForm1.New1Click(Sender: TObject);
var
  Filename: String;
begin
if InputQuery('New macro', 'Enter name for macro:', Filename) then begin
  //Check if file already exists:
  if FileExists(ChangeFileExt(Filename, '.mcr')) and
    (MessageDlg('A macro with the name '+ChangeFileExt(Filename, '.mcr')+#13+
                'already exists! Do you want to overwrite it ?', mtWarning,
                [mbYes, mbNo], 0)=idNo) then exit;
  MacroMagic.MacroName:=ChangeFileExt(Filename, '.mcr');
  Form1.Caption:=ChangeFileExt(Filename, '');
  RecordButton.Enabled:=true;
  PlayButton.Enabled:=true;
  StopButton.Enabled:=false;
end;
end;

procedure TForm1.Open1Click(Sender: TObject);
begin
if OpenDialog1.execute then begin
  MacroMagic.MacroName:=OpenDialog1.Filename;
  Form1.Caption:=ChangeFileExt(OpenDialog1.Filename, '');
  RecordButton.Enabled:=true;
  PlayButton.Enabled:=true;
  StopButton.Enabled:=false;
end;
end;

procedure TForm1.Exit1Click(Sender: TObject);
begin
Close;
end;

procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
if MessageDlg('Are you sure you want to exit ?', mtConfirmation,
              [mbYes, mbNo],0)=idYes then
  CanClose:=true
  else CanClose:=false;
end;

procedure TForm1.MacroMagicPlayEnded;
begin
RecordButton.Enabled:=true;
PlayButton.Enabled:=true;
end;

procedure TForm1.MacroMagicRecordEnded;
begin
RecordButton.Enabled:=true;
PlayButton.Enabled:=true;
StopButton.Enabled:=false;
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  i: integer;
  Counter: integer;
begin
MacroMagic.Pause; //This method-call is needed for the auto-speed addaption.
if RadioGroup1.ItemIndex=0 then
  Counter:=5000
else if RadioGroup1.ItemIndex=1 then
  Counter:=1000
else Counter:=200;
for i:=1 to Counter do begin
  Form1.Caption:=IntToStr(i);
end;
MacroMagic.Resume; //This method-call is needed for the auto-speed addaption.
end;

end.
